package Chum::DB::Jaspar;

use vars qw(@ISA @JASPAR_PARAMS %OK_FIELD $AUTOLOAD);

use strict;
use Bio::Root::Root;
use Chum::DB::MatrixDB;
use Data::Dumper;
require TFBS::DB::JASPAR4;
require TFBS::MatrixSet;

@ISA = qw( Chum::DB::MatrixDB );

BEGIN {
	@JASPAR_PARAMS = qw(dbname host user pass);
	foreach my $attr (@JASPAR_PARAMS)
		{ $OK_FIELD{$attr}++; }
}

sub new {
	my($class, @args) = @_;
	my $self = $class->SUPER::new(@args);
	while (@args) {
		my $attr = shift @args;
		my $value = shift @args;
		$self->$attr($value);
	}
	if (!defined($self->{'dbname'})) { $self->{'dbname'} = "jaspar_4_02_09_04"; }
	if (!defined($self->{'host'})) { $self->{'host'} = "db01"; }
	if (!defined($self->{'user'})) { $self->{'user'} = "ensembl"; }
	if (!defined($self->{'pass'})) { $self->{'pass'} = "ensembl"; }

	$self->{'db'} = TFBS::DB::JASPAR4->connect("dbi:mysql:" . $self->{'dbname'} . ":" . $self->{'host'},
							$self->{'user'},
							$self->{'pass'});

	return $self;
}

sub AUTOLOAD {
    my $self = shift;
    my $attr = $AUTOLOAD;
    $attr =~ s/.*:://;

    $self->throw("Unallowed parameter: $attr !") unless $OK_FIELD{$attr};
    $self->{$attr} = shift if @_;
    return $self->{$attr};
}

