#!/usr/bin/perl
use strict;
use Data::Dumper;

##RAW
my $w_500 = "../../data/R/wilcox.results.500.txt";
my $w_1000 = "../../data/R/wilcox.results.1000.txt";
my $w_1500 = "../../data/R/wilcox.results.1500.txt";
my $w_2000 = "../../data/R/wilcox.results.2000.txt";

##MTP
my $w_mtp_500 = "../../data/R/wilcox.results.500.mtp.test.txt";
my $w_mtp_1000 = "../../data/R/wilcox.results.1000.mtp.test.txt";
my $w_mtp_1500 = "../../data/R/wilcox.results.1500.mtp.test.txt";
my $w_mtp_2000 = "../../data/R/wilcox.results.2000.mtp.test.txt";

my $ids_arrayref = getIds($w_mtp_500);

my $data_500 = readWilcoxFile($w_500);
my $data_1000 = readWilcoxFile($w_1000);
my $data_1500 = readWilcoxFile($w_1500);
my $data_2000 = readWilcoxFile($w_2000);

my $mtp_data_500 = readMtpFile($w_mtp_500);
my $mtp_data_1000 = readMtpFile($w_mtp_1000);
my $mtp_data_1500 = readMtpFile($w_mtp_1500);
my $mtp_data_2000 = readMtpFile($w_mtp_2000);

print "NAME\ta500\ta1000\ta1500\ta2000\tg500\tg1000\tg1500\tg2000\n";
foreach my $key (@$ids_arrayref) {
    print $key . "\t" .  $data_500->{$key}->{'all'} . "\t" . $data_1000->{$key}->{'all'} . "\t";
    print $data_1500->{$key}->{'all'} . "\t" . $data_2000->{$key}->{'all'} . "\t";
    print $data_500->{$key}->{'group'} . "\t" . $data_1000->{$key}->{'group'} . "\t";
    print $data_1500->{$key}->{'group'} . "\t" . $data_2000->{$key}->{'group'} . "\n";
    print "\t" .  $mtp_data_500->{$key}->{'all_mtp'} . "\t" . $mtp_data_1000->{$key}->{'all_mtp'} . "\t";
    print $mtp_data_1500->{$key}->{'all_mtp'} . "\t" . $mtp_data_2000->{$key}->{'all_mtp'} . "\t";
    print $mtp_data_500->{$key}->{'group_mtp'} . "\t" . $mtp_data_1000->{$key}->{'group_mtp'} . "\t";
    print $mtp_data_1500->{$key}->{'group_mtp'} . "\t" . $mtp_data_2000->{$key}->{'group_mtp'} . "\n";
}
exit(0);

sub readWilcoxFile() {
    my $file = shift;
    my %data;
    open (FILE, $file) || die("Cannot open file $file");
    while (my $line = <FILE>) {
        chomp($line);
        if ($line =~ /"([\S]+)"[\s]+([\S]+)[\s]+([\S]+)/g) {
            my %data_i = ('all' => $2,
                          'group' => $3);
            $data{$1} = \%data_i;
        }
    }
    close(FILE);
    return \%data;
}

sub readMtpFile() {
    my $file = shift;
    my %data;
    open (FILE, $file) || die("Cannot open file $file");
    while (my $line = <FILE>) {
        chomp($line);
        if ($line =~ /"([\S]+)"[\s]+([\S]+)[\s]+([\S]+)[\s]+([\S]+)[\s]+([\S]+)/g) {
            my %data_i = ('group_raw' => $2,
                          'group_mtp' => $3,
                          'all_raw' => $4,
                          'all_mtp' => $5);
            $data{$1} = \%data_i;
        }
        
    }
    close(FILE);
    return \%data;
}

sub getIds() {
    my $file = shift;
    my @data;
    open (FILE, $file) || die("Cannot open file $file");
    while (my $line = <FILE>) {
        chomp($line);
        if ($line =~ /"([\S]+)"[\s]+([\S]+)[\s]+([\S]+)[\s]+([\S]+)[\s]+([\S]+)/g) {
            push @data, $1;
        }
        
    }
    close(FILE);
    return \@data;
}

