#!/usr/bin/perl

use strict;
use Data::Dumper;
use Chum::Analysis::Local::Weeder;
use Chum::Utils::RSNPAnalysisXMLFileReader;

###############################################LOAD INPUT PARAMETERS
my $rsnpa_xml_file;
for (my $i = 0; $i < @ARGV; $i++) {
	if ($ARGV[$i] =~ /-f/) {
		$rsnpa_xml_file = $ARGV[++$i];
	} else {
		print STDERR "\nInvalid parameter: " . $ARGV[$i] . "\n";
		exit(1);
	}
}
if (!defined($rsnpa_xml_file)) { die("ERROR: Input file not defined: -f\n"); }
unless (-e $rsnpa_xml_file) { die("ERROR: Input file does not exist $rsnpa_xml_file\n"); }

###############################################ANALYZE INPUT FILE
my $rsnpa_obj = new Chum::Utils::RSNPAnalysisXMLFileReader(-file => $rsnpa_xml_file);
my $stack = $rsnpa_obj->get_sequence_stack_obj('hosa');

my $weeder = new Chum::Analysis::Local::Weeder();
$weeder->{'binary'} = "/home/smontgom/chinook-internal-server/services/weeder/Weeder1.0.1/weederlaunchersm.pl";
my $meta_input_hashref = $weeder->get_meta_input_hashref;
$meta_input_hashref->{'-o'} = "HS";
$meta_input_hashref->{'-r'} = "small";
$meta_input_hashref->{'-s'} = "";
$meta_input_hashref->{'-m'} = "";
$meta_input_hashref->{'-t'} = "10";
$weeder->run_program($stack->reference_sequence, $stack, "/tmp/foo.out", $meta_input_hashref);

#my $resultset = $weeder->run_variation_analysis($stack, $meta_input_hashref);
##############################################################INTERPRET ANALYSIS RESULTS FOR VARIATION
#if(defined($resultset)) {
#	my $winterpretter = new Chum::Result::Interpretter::WeederInterpretter();	
#	my $variation_name = $stack->get_variation_name;
#	my $score = $winterpretter->interpret($resultset);
#	print STDERR $stack->reference_sequence->sequence->seq . "\n";
#	foreach my $variant_sequence (@{$stack->variant_sequences}) {
#		print STDERR $variant_sequence->sequence->seq . "\n";
#	}
#	print STDERR "CHUMRES:\t" . $variation_name . "\tWEEDER\t" . $score .  "\t" . $stack->get_sequence_ids_string . "\n";
#	print "CHUMRES:\t" . $variation_name . "\tWEEDER\t" . $score .  "\t" . $stack->get_sequence_ids_string . "\n";
#} else {
#	die "ERROR: Could not get results\n";
#}
