#!/usr/bin/perl

use strict;
use Chum::Utils::RSNPAnalysisXMLFileReader;
use Data::Dumper;

my $directory;
for (my $i = 0; $i < @ARGV; $i++) {
    if ($ARGV[$i] =~ /-d/) {
        $directory = $ARGV[++$i];
    } else {
        print STDERR "\nInvalid parameter: " . $ARGV[$i] . "\n";
        exit(1);
    }
}
if (!defined($directory)) { die("RSNPA directory is not defined"); }
unless(-d $directory) { die("RSNPA directory does not exist: " . $directory); }

my @rsnpa_files = glob($directory . "/*xml");
#print Dumper \@rsnpa_files;
foreach my $file (@rsnpa_files) {
    my $rsnpa_obj = new Chum::Utils::RSNPAnalysisXMLFileReader(-file => $file);
    my $stack_object = $rsnpa_obj->get_sequence_stack_obj('hosa');
    my @variant_sequences = @{$stack_object->variant_sequences};
    my $printed = 0;
    if (@variant_sequences) {
        if (scalar(@variant_sequences) >= 1) {
            print $stack_object->get_variation_name . "\t";
            print $stack_object->reference_sequence->allele_sequence->seq . "\t";
            print $variant_sequences[0]->allele_sequence->seq . "\n";
            $printed = 1;
        }
    }
    if (!$printed) {
        print $stack_object->get_variation_name . "\t" . "FAILED\n";
    }

}

exit(0);
