#!/usr/bin/perl

use strict;

use strict;
use Bio::Tools::GFF;
use Data::Dumper;

#######################################################################################################
##LOAD EACH COMMAND-LINE PARAMETER INTO THE APPROPRIATE VARIABLE#######################################
#######################################################################################################
my $mapping_directory;
for (my $i = 0; $i < @ARGV; $i++) {
    if ($ARGV[$i] =~ /-d/) {
        $mapping_directory = $ARGV[++$i];
    } else {
        print "\nInvalid parameter: " . $ARGV[$i] . "\n";
        exit(1);
    }
}
if (!defined($mapping_directory)) {
        print "\nSome parameters not defined, ";
        print "usage ./createRPolyPipeJobs.pl ";
        print "-d mapping_dir\n";
        exit(1);      
} 

#######################################################################################################
##GET ALL THE MAPPING FILES############################################################################
#######################################################################################################
my @mapping_files = glob($mapping_directory . "/*.mapping");


#######################################################################################################
##PROCESS EACH MAPPING FILE############################################################################
#######################################################################################################

my %id

my $i = 1;
foreach my $mapping_file (@mapping_files) {
	#open gff file, get ensg id annotation, create job, based on annotation
	my $gffio = Bio::Tools::GFF->new(-file => $mapping_file, -gff_version => 2);
	my $feature = $gffio->next_feature();
	if (defined($feature)) {
		my @ensgene = $feature->annotation->get_Annotations('ensGeneId');
		if (defined(@ensgene)) {
			if (scalar(@ensgene) == 1) {
				my $ensgeneid = @ensgene[0];
				print STDERR "Found: " . $ensgeneid . "\t" . $i++ . "\n";



			}
		}
	}
	$gffio->close();
}

